don/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('', include('web.urls')),
    path('api/', include('don_api.urls')),
]

if settings.DEBUG:
    urlpatterns += [
        path('admin/', admin.site.urls),
        path("__debug__/", include("debug_toolbar.urls")),
    ]

web/urls.py
from django.conf import settings
from django.urls import path
from django.views import defaults as default_views
from django.views.generic.base import RedirectView
from django.urls import reverse_lazy

from .views.api import (
    APIListView, APIDetailView, APISpecificationView, APIAddView,
    APIAddSuccessView, APIValidatorReportsView, OpenApiSpecGenerator
)
from .views.generic import TemplateView
from .views.index import RootRedirectView
from .views.organization import OrganizationDetailView, OrganizationListView
from .views.repository import RepositoryListView, RepositoryAddView, RepositoryAddSuccessView, RepositoryDetailView
from .views.statistics import StatisticsView, APIStatisticsView

app_name = "web"


def redirect_view(view_url):
    """
    Helper view function specifically for the redirects below since they take
    a kwarg slug as an argument.
    """
    return RedirectView.as_view(
        url=reverse_lazy(view_url, kwargs={}),
        permanent=True)


urlpatterns = [
    path("", RootRedirectView.as_view(), name="index_redirect"),
    path("apis", APIListView.as_view(), name="api_list"),
    path("apis/toevoegen", APIAddView.as_view(), name="api_add"),
    path("apis/toevoegen/succes", APIAddSuccessView.as_view(), name="api_add_success"),
    path("apis/<slug:api_id>", APIDetailView.as_view(), name="api_detail"),
    path("apis/<slug:api_id>/score-details", APIValidatorReportsView.as_view(), name="api_validator_reports"),
    path("apis/<slug:api_id>/specificatie/<str:environment_name>", APISpecificationView.as_view(),
         name="api_specification"),
    path("organisaties", OrganizationListView.as_view(), name="organization_list"),
    path("organisaties/<slug:slug>", OrganizationDetailView.as_view(), name="organization_detail"),
    path("repositories", RepositoryListView.as_view(), name="repository_list"),
    path("repositories/<slug:slug>", RepositoryDetailView.as_view(), name="repository_detail"),
    path('repositorys', redirect_view('web:repository_list')),
    path("toevoegen/repository", RepositoryAddView.as_view(), name="repository_add"),
    path("toevoegen/repository/succes", RepositoryAddSuccessView.as_view(), name="repository_add_success"),
    path("statistieken", StatisticsView.as_view(), name="statistics"),
    path("api-statistieken", APIStatisticsView.as_view(), name="statistics"),
    path("tools/oas-generator", OpenApiSpecGenerator.as_view(), name="oas_generator"),
    # path("kennisplatform-apis", KennisplatformApisView.as_view(), name="kennisplatform-apis"),
    # path("kennisplatform-apis/intentieverklaring-api-strategie", IntentieverklaringView.as_view(), name="intentieverklaring-api-strategie"),
    path("contact", TemplateView.as_view(title="Contact", template_name="contact.html"), name="contact"),
    path("over", TemplateView.as_view(
        title="Over Developer Overheid",
        description="Eén centrale plek voor de developer die voor of met de overheid ontwikkelt",
        template_name="content/about.html",
    ), name="content_about"),
    path("privacy", TemplateView.as_view(title="Privacyverklaring", template_name="content/privacy.html"),
         name="content_privacy"),
    path(".well-known/security.txt", RedirectView.as_view(url="https://www.ncsc.nl/.well-known/security.txt")),
]

if settings.DEBUG:
    urlpatterns += [
        path("error/400", default_views.bad_request, {"exception": Exception("Bad request")}),
    path("error/404", default_views.page_not_found, {"exception": Exception("Page not Found")}),
        path("error/500", default_views.server_error),
    ]

core/models/api.py
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _

from . import MAX_ENUM_LENGTH, MAX_TEXT_LENGTH, MAX_URL_LENGTH

from .organization import Organization
from .topic import Topic
from .validator import ForeignValidatorReport, BaseValidatorReport, ValidatorReportsMixin


class API(ValidatorReportsMixin["APIValidatorReport"], models.Model):
    class APIType(models.TextChoices):
        UNKNOWN = 'unknown', 'Onbekend'
        ODATA = 'odata', 'OData'
        REST_JSON = 'rest_json', 'REST/JSON'
        REST_XML = 'rest_xml', 'REST/XML'
        SOAP_XML = 'soap_xml', 'SOAP/XML'
        GRPC = 'grpc', 'gRPC'
        GRAPHQL = 'graphql', 'GraphQL'
        SPARQL = 'sparql', 'SPARQL'
        WFS = 'wfs', 'WFS'
        WMS = 'wms', 'WMS'

    class APIAuthentication(models.TextChoices):
        UNKNOWN = 'unknown', 'Unknown'
        NONE = 'none', 'None'
        MUTUAL_TLS = 'mutual_tls', 'Mutal TLS'
        API_KEY = 'api_key', 'API key'
        IP_ALLOW_LIST = 'ip_allow_list', 'IP allow list'
        OAUTH2 = "oauth2", "OAuth 2.0"

    api_id = models.CharField(max_length=MAX_TEXT_LENGTH, unique=True)
    description = models.TextField()
    organization = models.ForeignKey(
        Organization, verbose_name=_("organization"), on_delete=models.PROTECT)
    service_name = models.CharField(max_length=MAX_TEXT_LENGTH)
    api_type = models.CharField(
        max_length=MAX_ENUM_LENGTH,
        choices=APIType.choices,
        default=APIType.UNKNOWN
    )
    api_authentication = models.CharField(
        max_length=MAX_ENUM_LENGTH,
        choices=APIAuthentication.choices,
        default=APIAuthentication.UNKNOWN
    )
    is_reference_implementation = models.BooleanField(default=False)

    contact_email = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    contact_phone = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    contact_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    terms_government_only = models.BooleanField(null=True)
    terms_pay_per_use = models.BooleanField(null=True)
    terms_uptime_guarantee = models.DecimalField(
        null=True,
        decimal_places=6,
        max_digits=8,
    )
    terms_support_response_time = models.PositiveIntegerField(
        help_text='Measured in number of workdays',
        null=True,
    )

    forum_vendor = models.CharField(max_length=MAX_ENUM_LENGTH, blank=True)
    forum_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    discourse_topic_url = models.CharField(max_length=MAX_URL_LENGTH, blank=True)

    badges = models.ManyToManyField(
        'Badge',
        through='APIBadge',
        related_name='apis',
    )
    referenced_apis = models.ManyToManyField(
        'self',
        through='Relation',
        symmetrical=False,
        related_name='referenced_by_apis',
    )
    topics = models.ManyToManyField(Topic)

    def __str__(self):
        return self.api_id

    def get_absolute_url(self):
        return reverse("web:api_detail", kwargs={"api_id": self.api_id})

    def get_production_environment(self):
        return self.environments.filter(name=Environment.EnvironmentType.PRODUCTION).first()

    ADR_TESTABLE_TYPES = (APIType.REST_JSON.ODATA, APIType.REST_JSON, APIType.REST_XML)
    """API's of these types can be tested on API Design Rules"""

    def is_adr_testable(self):
        return self.api_type in self.ADR_TESTABLE_TYPES

    class Meta:
        verbose_name = _("API")
        verbose_name_plural = _("APIs")


class Environment(models.Model):
    class EnvironmentType(models.TextChoices):
        PRODUCTION = 'production', 'Production'
        ACCEPTANCE = 'acceptance', 'Acceptance'
        TEST = 'test', 'Test'
        DEMO = 'demo', 'Demo'

    name = models.CharField(max_length=MAX_ENUM_LENGTH, choices=EnvironmentType.choices)
    api_url = models.URLField(max_length=MAX_URL_LENGTH)
    specification_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)
    documentation_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.CASCADE,
        related_name='environments',
    )

    def __str__(self):
        return f"{self.name} - {self.api_url}"


class Relation(models.Model):
    TYPE_REFERENCE_IMPLEMENTATION = "reference-implementation"

    name = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    from_api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.CASCADE,
        related_name='relations_from',
    )
    to_api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.PROTECT,
        related_name='relations_to',
    )

    def __str__(self):
        return f'{self.from_api_id} {self.name} {self.to_api_id}'


class APIValidatorReport(BaseValidatorReport):
    api = ForeignValidatorReport(API)

web/views/kennisplatform_apis.py
from .generic import TemplateView
from .mixins import Breadcrumb

from django.urls import reverse_lazy


class KennisplatformApisView(TemplateView):
    title = "Kennisplatform API's"
    template_name = "kennisplatform-apis.html"
    description = "Het Kennisplatform API is een open platform waar overheden, marktpartijen, gebruikers en aanbieders samen werken aan een Nederlandse API strategie en alles wat daar verder bij komt kijken. Wil je meedoen?"

    breadcrumb = Breadcrumb(title=title, url=reverse_lazy("web:kennisplatform-apis"))


class IntentieverklaringView(TemplateView):
    title = "Intentieverklaring API Strategie"
    template_name = "intentieverklaring-api-strategie.html"
    description = "De intentieverklaring is opgesteld door het Kennisplatform API's in opdracht van het Ministerie van BZK. Het Kennisplatform API's is een samenwerkingsverband dat zich inzet voor het bevorderen van de uitwisseling van data en diensten binnen de overheid door middel van standaarden en API's."

    breadcrumb = Breadcrumb(title=title, url=reverse_lazy("web:intentieverklaring-api-strategie"))

    def get_breadcrumbs(self):
        return (
            KennisplatformApisView.breadcrumb,
            self.breadcrumb,
        )

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        img_path = "images/"
        context["organizations"] = [
            {
                "img": img_path + "FORUM_STANDAARDISATIE_LOGO_RGB-01_0.png",
                "name": "Larissa Zegveld",
                "role": "Voorzitter Forum Standaardisatie"
            }, {
                "img": img_path +"logius.png",
                "name": "Ing. P.J. den Held RI",
                "role": "Directeur Digitale Programma's"
            }, {
                "img": img_path + "SVB.png",
                "name": "Britt van den Berg",
                "role": "CIO"
            }, {
                "img": img_path + "Kadaster.png",
                "name": "Rob Agelink",
                "role": "CDO"
            }, {
                "img": img_path + "vng.png",
                "name": "Theo Peters",
                "role": "CTO"
            }, {
                "img": img_path + "RVIG.png",
                "name": "Michiel van der Veen",
                "role": "directeur Innovatie en Ontwikkeling"
            }, {
                "img": img_path + "KVK_1.png",
                "name": "Marije Hovestad",
                "role": "Directeur Dataverstrekking"
            }, {
                "img": img_path + "minvenj.png",
                "name": "Raymond Kers",
                "role": ""
            }, {
                "img": img_path + "Geonovum-ruimte.png",
                "name": "Rob van de Velde",
                "role": "Directeur"
            }
        ]
        return context

web/views/statistics.py
from core.models.repository import RepositoryProgrammingLanguage, get_programming_languages_count
from .generic import TemplateView


def get_top_programming_languages():

    repository_programming_languages = RepositoryProgrammingLanguage.objects.select_related(
        "programming_language",
    ).all()

    return get_programming_languages_count(repository_programming_languages)[:40]


class StatisticsView(TemplateView):
    template_name = "statistics.html"
    title = "Statistieken"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        context["top_programming_languages"] = get_top_programming_languages()

        return context


class APIStatisticsView(TemplateView):
    template_name = "api-statistics.html"
    title = "Statistieken"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        return context

web/templates/api-statistics.html
{% extends "layouts/base.html" %}
{% load static don_template_functions %}

{% block content %}
<div class="page-statistics">

    <div class="container"><h1 class="mb-5">API Dashboard</h1></div>
    <div id="don-stats-app"></div>
</div>
{% endblock %}
{% block tail %}
<script src="{% static 'dist/don-stats-app.js' %}"></script>
{% endblock %} 

web/templates/api_add_success.html
{% extends "layouts/base.html" %}
{% load static i18n don_template_functions %}

{% block content %}
<div class="container">
    <h1 class="mb-6">{{ title }}</h1>
    <p class="font-size-lg">API is toegevoegd. Deze wordt zo snel mogelijk geplaatst.</p>
    <a href="{% url 'web:api_list' %}" class=" button btn-seconday mt-6 mb-12">
        Terug naar API overzicht
    </a>
</div>
{% endblock %}

web/templates/api_detail.html
{% extends "layouts/base.html" %}
{% load static i18n don_template_functions %}

{% block content %}
    <div class="page-api-detail container">
        <div class="flex flex-col md:flex-row justify-between w-full">
            <div class="left">
                <div class="flex">
                    <h1 class="page-title mb-0">{{ title }}</h1>
                    <span class="pill pill--white hide-upto-sm mb-1 ml-2">{{ api.get_api_type_display }}</span>
                </div>
                <a href="{{ api.organization.get_absolute_url }}" class="page-subtitle mb-2">{{ api.organization.name }}</a>
                <p class="intro mt-4">{{ api.description }}</p>
                <span class="pill pill--white hide-from-sm">{{ api.get_api_type_display }}</span>
            </div>
            <div class="flex flex-col items-end w-1/5 ml-6 just">
                <div class="topic-button mt-4 md:mt-0 mb-4">
                    {% include "partials/API_topic_button.html" with api=api %}
                </div>
                <div class="api-topics w-full">
                    <p class="mb-1 font-description-term font-bold">Thema's</p>
                    {% if api.topics.all %}
                        {% for topic in api.topics.all %}
                        <span class="topic-pill pill bg-white mb-1">{{ topic }}</span>
                        {% endfor %}
                    {% else %}
                    <i>Geen thema's ingevuld.</i>
                    {% endif %}
                </div>
            </div>
        </div>
        <dl class="api-props vertical-sm mt-6 mb-6">
            <div>
                <dt class="font-bold">API Authenticatie</dt>
                <dd>
                    {{ api.api_authentication | format_api_authentication }}
                </dd>
            </div>
            <div>
                <dt class="font-bold">Gebruik</dt>
                <dd>
                    {% if api.terms_government_only %}
                    Alleen overheid
                    {% else %}
                    Iedereen
                    {% endif %}
                </dd>
            </div>
            <div>
                <dt class="font-bold">Kosten</dt>
                <dd>
                    {% if api.terms_pay_per_use %}
                    Kosten voor gebruik
                    {% else %}
                    Gratis
                    {% endif %}
                </dd>
            </div>
            <div>
                <dt class="font-bold">Uptime garantie</dt>
                <dd>
                    {% if api.terms_uptime_guarantee %}
                    {% language "nl" %}
                    {{ api.terms_uptime_guarantee | floatformat:-2 }}{% endlanguage %}%
                    {% else %}
                    Geen
                    {% endif %}
                </dd>
            </div>
            <div>
                <dt class="font-bold">Helpdesk respons</dt>
                <dd>
                    {% if api.terms_support_response_time %}
                    {{ api.terms_support_response_time }}
                    werkdag{{ api.terms_support_response_time | pluralize:"en" }}
                    {% else %}
                    Geen
                    {% endif %}
                </dd>
            </div>
        </dl>
        <a
        class="flex items-center mt-0 mb-10"
        target="_blank"
        href="https://gitlab.com/commonground/don/don-content/-/blob/main/content/api/{{ api.api_id }}.yaml"
        rel="noopener noreferrer"
        data-goatcounter-click="event:api-edit-content:{{ api.api_id }}"
        data-goatcounter-title="'Pas content aan' knop"
        data-goatcounter-referrer="{{ request.build_absolute_uri }}"
        >
            <svg class="icon icon--md mr-1" aria-hidden="true">
                <use href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-edit" />
            </svg>
            Pas content aan op Gitlab
        </a>
        <div class="environments card card--padding-md mb-4">
            <h2>Omgevingen</h2>
            {% for environment in api.environments.all %}
            <div class="environments__env">
                <h3>{{ environment.name }}</h3>
                <div class="environments__env__urls">
                    <code class="code py-3">{{ environment.api_url }}</code>
                    {% if environment.specification_url %}
                    <a href="{% url 'web:api_specification' api.api_id environment.name %}"
                        class="button button--primary">Specificatie</a>
                    {% else %}
                    <span class="button button--disabled">Specificatie</span>
                    {% endif %}
                    {% if environment.documentation_url %}
                    <a href="{{ environment.documentation_url }}"
                        class="button button--external-link"
                        target="_blank"
                        rel="noopener noreferrer">Documentatie
                        <img src="{% static 'images/icons/external-link.svg' %}"
                            width="16"
                            height="16"
                            alt="">
                    </a>
                    {% else %}
                    <span class="button button--disabled">Documentatie</span>
                    {% endif %}
                </div>
            </div>
            {% endfor %}
        </div>
        {% if api.forum_url %}
        <div class="card p-4 mt-4 flex flex-col items-start">
            <h2>Community</h2>
            <a href="{{ api.forum_url }}"
                class="button button--external-link"
                target="_blank"
                rel="noopener noreferrer">Ga naar community
                <img src="{% static 'images/icons/external-link.svg' %}"
                    width="16"
                    height="16"
                    alt="">
            </a>
        </div>
        {% endif %}
        {% with repository_list=api.related_repositories.all %}
            {% if repository_list %}
            <div class="related-repositories card mb-">
                <h2>Code</h2>
                <p>
                    {{ repository_list | length }} open source
                    {% if repository_list.count == 1 %}
                    project gebruikt
                    {% else %}
                    projecten gebruiken
                    {% endif %}
                    deze API
                </p>
                <ul class="list-reset">
                    {% for repository in repository_list %}
                        {% repository_item repository %}
                    {% endfor %}
                </ul>
            </div>
            {% endif %}
        {% endwith %}
        {% if implemented_by_api_list %}
        <div class="related-apis card card--padding-md">
            <h2>Geïmplementeerd door</h2>
            <ul class="list-reset">
                {% for api in implemented_by_api_list %}
                {% include "partials/api_item.html" with api=api cssClass="card" %}
                {% empty %}Er zijn momenteel geen API's die verwijzen naar deze referentie-implementatie.
                {% endfor %}
            </ul>
        </div>
        {% elif implemented_for_api_list %}
        <div class="related-apis card card--padding-md">
            <h2>
                Referentie implementatie{{ implemented_for_api_list | pluralize:"s" }}
            </h2>
            <ul class="list-reset">
                {% for api in implemented_for_api_list %}
                {% include "partials/api_item.html" with api=api %}
                {% endfor %}
                </ul>
                </div>
                {% endif %}
        {% if api.latest_validator_reports.count %}
        <h2 class="mt-6">API scores</h2>
        {% include "partials/validator_reports_summary.html" with validator_reports=api.latest_validator_reports %}
        <a href="{% url 'web:api_validator_reports' api_id=api.api_id %}" class="button button--primary align-self-end">
            API score details
            <svg class="button__icon button__icon--last button__icon--small-width">
                <use href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-chevron-right" />
            </svg>
        </a>
        {% endif %}
    </div>
{% endblock %}

web/templates/api_list.html
{% extends "layouts/base.html" %}
{% load static %}

{% block content %}
<div class="container">
    <h1 class="mb-5">{{ title }}</h1>
    <p class="mb-0">{{ description }}</p>
    <div id="list-results" class="page-search">
        {% include "partials/api_list_results.html" %}
    </div>
</div>
{% endblock %}

{% block tail %}
<script src="{% static 'dist/htmx.js' %}"></script>
{% endblock %}

web/templates/contact.html
{% extends "layouts/base.html" %}
{% load i18n %}

{% block content %}
<div class="container mb-12">
    <div class="text-container">
        <h1>{{ title }}</h1>
        <p>Heb je vragen of ideeën? Plaats dan een bericht op 
            <a href="https://community.developer.overheid.nl/" target="_blank">onze community</a>.
            Door een discussie te starten op onze community kunnen we samen opzoek naar de juiste oplossing.
        </p>
        <p>
            Als je liever privé contact wilt opnemen, kan je ons een mail sturen naar 
            <a href="mailto:developer.overheid@geonovum.nl">developer.overheid@geonovum.nl</a>.
        </p>
    </div>
</div>
{% endblock %}

web/templates/index.html
{% extends "layouts/base.html" %}
{% load static don_template_functions %}

{% block content %}
<div class="page-homepage">
    <div class="hero pt-24 pb-32">
        <div class="hero--bg">
            <img src="{% static 'images/hero_bg.webp' %}">
        </div>
        <div class="container">
            <div class="hero__intro mb-0">
                <h1 class="hero__intro__heading mb-2">Developer Portal van de Nederlandse Overheid</h1>
                <p class="hero__intro__subtitle mb-0">
                    Eén centrale plek voor de developer die voor of met de overheid
                    ontwikkelt
                </p>
            </div>
        </div>
    </div>
    {% include "partials/call_to_action_cards.html" %}   
    <div class="container container--lg mt-8 mb-20 community-overview">
        {% for category in community_categories %}
        <div class="category mb-8 p-3 px-4 card">
            <div class="category__title mb-3">
                {% include "partials/tabler-icon.html" with icon_title=category.icon classname="size-10" %}
                <h2 class="category__title__heading text-xl ml-2">{{ category.title }}</h2>
            </div>
            <div class="md:grid grid-cols-4 gap-2">
                {% for item in category.items %}
                <a class="card--bg p-2 px-3 category__pages__page mb-2 md:mb-0" href="{{ item.link }}">
                    <h3 class="category__pages__page__title text-lg">{{ item.title }}</h3>
                    <div class="category__pages__page__organization">
                        {% if item.organization == "digilab" %}
                            <img src="{% static 'images/digilab.svg' %}" width="16" class="mr-1 size-4">
                            <span class="text-sm">Digilab</span>
                        {% elif item.organization == "kadaster" %}
                            <img src="{% static 'images/logo-kadaster.svg' %}" width="16" class="mr-1 size-4">
                            <span class="text-sm">Kadaster</span>
                        {% elif item.organization == "rijks_ict_gilde" %}
                            <img src="{% static 'images/rijksictgilde_logo.jpeg' %}" width="16" class="mr-1 size-4">
                            <span class="text-sm">Rijks ICT Gilde</span>
                        {% elif item.organization == "ictu" %}
                            <img src="{% static 'images/ictu_logo.jpg' %}"  width="16" class="mr-1 size-4">
                            <span class="text-sm">ICTU</span>
                        {% elif item.organization == "vws" %}
                            <img src="{% static 'images/logo-vws.jpg' %}" class="mr-1 size-4">
                            <span class="text-sm" title="Ministerie van Volksgezondheid, Welzijn en Sport">{{ "Ministerie van Volksgezondheid, Welzijn en Sport" | truncatechars:25 }}</span>
                        {% elif item.organization == "kpa" %}
                            <img src="{% static 'images/logo_icon_kpa.png' %}" class="mr-1 size-4">
                            <span class="text-sm">Kennisplatform API's</span>
                        {% elif item.organization == "forum-standaardisatie" %}
                            <img src="{% static 'images/logo_forum_standaardisatie_small.png' %}" class="mr-1 size-4">
                            <span class="text-sm">Forum Standaardisatie</span>
                        {% elif item.organization == "nl-design-system" %}
                            <img src="{% static 'images/logo_nld.png' %}" class="mr-1 size-4">
                            <span class="text-sm">NL Design System</span>
                            {% elif item.organization == "developer-italia" %}
                            <img src="{% static 'images/logo-it.png' %}" class="mr-1 size-4">
                            <span class="text-sm">Developer Italia</span>
                        {% else %}
                            <img src="{% static 'images/logo.svg' %}" alt="Logo Developer Overheid"  width="16" class="mr-1 size-4">
                            <span class="text-sm">Developer Overheid</span>
                        {% endif %}
                    </div>
                    <p class="category__pages__page__summary mb-0 text-sm">{{ item.summary }}</p>
                    {% if item.tags|length > 0 %}
                    <div class="category__pages__page__tags">
                        {% for tag in item.tags %}
                            <span class="pill pill--white pill--xs">{{ tag }}</span>
                        {% endfor %}
                    </div>
                    {% endif %}
                </a>
                {% endfor %}
            </div>
            <a href="{{ category.community_link }}" class="category__link font-normal mt-2" target="_blank">
                {{ category.link_text }}
                <svg width="20" height="20" class="icon">
                    <use href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-arrow-right" />
                </svg>
            </a>
        </div>
        {% endfor %}
    </div>
{% endblock %}

web/templates/oas_generator.html
{% extends "layouts/base.html" %}
{% load don_template_functions static %}

{% block content %}

    <div class="container mb-10">
        <h1>OpenAPI Specification Generator</h1>
        <p class="font-size-lg">Pas de JSON in de linker editor aan om een OpenAPI Spec te genereren.</p>
    </div>

    <div class="page-oas-generator p-5 mb-12 m-6 card">        
        <div class="flex flex-row ">
            <div class="input-area mr-5">
                <div class="editor-header">
                    <h2>Input</h2>
                    
                </div>
                <div id="oas-generator-input-field" class="json-editor"></div>
            </div>
            <div class="output-area">
                <div class="editor-header">
                    <h2>Output (openapi.json)</h2>
                    <div>
                        <button type="submit" class="button mr-1" id="JSON-download-button">Download JSON
                            <svg class="buton__icon button__icon--last icon icon--md icon--stroke-lg">
                                <use href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-download" />
                            </svg>
                        </button>
                        <button type="submit" class="button" id="yml-download-button">Download YAML
                            <svg class="buton__icon button__icon--last icon icon--md icon--stroke-lg">
                                <use href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-download" />
                            </svg>
                        </button>
                        <button type="submit" class="button" id="yml-copy-button">Kopieer YAML
                            <svg class="buton__icon button__icon--last icon icon--md icon--stroke-lg">
                                <use href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-copy" />
                            </svg>
                        </button>
                    </div>
                </div>
                <div id="oas-generator-output-field" class="json-editor"></div>
            </div>
        </div>
    </div>

<link rel="stylesheet" href="{% static 'vendor/jsoneditor.css' %}">
<script src="{% static 'dist/oas-generator.js' %}" defer></script>
{% endblock %}